
/*
	GAudio 2.0.2, (C)2001 by Obraz Studio(R)
	This program is a part of the GAudio 2.0.2 SDK.

	Load a IT file and play it.
*/

	#include <conio.h>
	#include <stdio.h>
	#include "../../include/gaudio.h"

	using namespace gaudio;

unsigned	DllVersion;
GAudio		*gAudio;
TrackerIT	*IT;

void main()
{
	ErrCode err;

	DllVersion = getLibVersion();
	
	char rev = DllVersion & 0xf;
	char sec = (DllVersion >> 4) & 0xf;
	char prim = (DllVersion >> 8) & 0xf;
	printf("GAudio library version %ld.%ld.%ld\n\n", prim, sec, rev);

	printf("This example demonstrates how to load a IT file and play it.\n");
	printf("Press any key to start ..\n");
	getch();

	gAudio = new GAudio();
	err = gAudio->init(DEVICE_DSOUND, DEVICEFREQ_44K, FALSE);
	if (err != GA_OK) {
		printf(gAudio->getLastErrorString());
		getch();
		delete gAudio;
		return;
	}

	err = gAudio->installSoftwareMixer();
	if (err != GA_OK) {
		printf(gAudio->getLastErrorString());
		getch();
		delete gAudio;
		return;
	}

	gAudio->setAudioStageStatus(AUDIOSTAGE_TRK, TRUE);

	TrackerParameters ITParams;
	ZeroMemory(&ITParams, sizeof ITParams);
	ITParams.classID = CLSID_TRACKERIT;
	ITParams.fileName = "../../audio bin/beek-our_island.it";
	ITParams.flags = FLAG_LOOP;
	ITParams.input = INPUT_DISK;
	ITParams.output = OUTPUT_MIXER;
	ITParams.audioStage = AUDIOSTAGE_TRK;

	err = gAudio->getSoundClass(SOUNDCLASS_IT, &ITParams, (void**)&IT);
	if (err != GA_OK) {
		printf(gAudio->getLastErrorString());
		getch();
		delete gAudio;
		return;
	}

	IT->play();

	printf("\nPlaying, press any key to quit.\n");
	getch();

	IT->release();
	delete gAudio;
}
