
/*
	GAudio 2.0.2, (C)2001 by Obraz Studio(R)
	This program is a part of the GAudio 2.0.2 SDK.

	Load a MPEG file and play it.
*/

	#include <conio.h>
	#include <stdio.h>
	#include "../../include/gaudio.h"

	using namespace gaudio;

unsigned	DllVersion;
GAudio		*gAudio;
MPEGstream	*MPEG;

void main()
{
	ErrCode err;

	DllVersion = getLibVersion();
	
	char rev = DllVersion & 0xf;
	char sec = (DllVersion >> 4) & 0xf;
	char prim = (DllVersion >> 8) & 0xf;
	printf("GAudio library version %ld.%ld.%ld\n\n", prim, sec, rev);

	printf("This example demonstrates how to load a MPEG file and play it.\nNo use of GAudio software mixer, pure DirectSound.\n");
	printf("Press any key to start ..\n");
	getch();

	gAudio = new GAudio();
	err = gAudio->init(DEVICE_DSOUND, DEVICEFREQ_44K, FALSE);
	if (err != GA_OK) {
		printf(gAudio->getLastErrorString());
		getch();
		delete gAudio;
		return;
	}

	// ----------
	// The MPEG is played using MEMPROGRESS flag, thus the file is decoded progressively
	// Remove it if you want GAudio decodes it during init and then replay as a simple RAW sound

	StreamParameters MPEGParams;
	ZeroMemory(&MPEGParams, sizeof MPEGParams);
	MPEGParams.classID = CLSID_MPEGSTREAM;
	MPEGParams.fileName = "../../audio bin/lagrandecote.mp3";
	MPEGParams.flags = FLAG_LOOP + FLAG_MEMPROGRESS;
	MPEGParams.input = INPUT_DISK;
	MPEGParams.output = OUTPUT_DSOUNDSOFT;

	err = gAudio->getSoundClass(SOUNDCLASS_MPEG, &MPEGParams, (void**)&MPEG);
	if (err != GA_OK) {
		printf(gAudio->getLastErrorString());
		getch();
		delete gAudio;
		return;
	}

	MPEG->play();
	printf("\nPlaying, press any key to quit.\n");
	getch();

	MPEG->release();
	delete gAudio;
}
