
/*
	GAudio 2.0.2, (C)2001 by Obraz Studio(R)
	This program is a part of the GAudio 2.0.2 SDK.

	Basic use of RAW class.
*/

	#include <conio.h>
	#include <math.h>
	#include <stdio.h>
	#include "../../include/gaudio.h"

	using namespace gaudio;

unsigned	DllVersion;
GAudio		*gAudio;
RAWstream	*RAW, *RAW2, *RAW3, *RAW4;

void main()
{
	ErrCode err;

	DllVersion = getLibVersion();

	char rev = DllVersion & 0xf;
	char sec = (DllVersion >> 4) & 0xf;
	char prim = (DllVersion >> 8) & 0xf;
	printf("GAudio library version %ld.%ld.%ld\n\n", prim, sec, rev);

	printf("This example demonstrates how to generate pure RAW sound and manage them\nas simple sound classes.\nOne immediate use of RAW class is the well known \"locked sound buffer\".\n");
	printf("Press any key to start ..\n");
	getch();

	gAudio = new GAudio();
	err = gAudio->init(DEVICE_DSOUND, DEVICEFREQ_44K, FALSE);
	if (err != GA_OK) {
		printf(gAudio->getLastErrorString());
		getch();
		delete gAudio;
		return;
	}

	RAWParameters RAWParams;
	ZeroMemory(&RAWParams, sizeof RAWParams);
	RAWParams.classID = CLSID_RAWSTREAM;
	RAWParams.flags = FLAG_LOOP;
	RAWParams.output = OUTPUT_DSOUND;
	RAWParams.nbChannels = 1;
	RAWParams.nbBits = 16;
	RAWParams.size = 400;

	err = gAudio->getSoundClass(SOUNDCLASS_RAW, &RAWParams, (void**)&RAW);
	if (err != GA_OK) {
		printf(gAudio->getLastErrorString());
		getch();
		delete gAudio;
		return;
	}

	char *buf = new char[400];
	for (int i = 0; i < 400; i++) {
		short val = cos ( i / 200.f * 3.14159f ) * 32767;
		buf[i] = val;
	}
	
	RAW->writeSample(0, 400, buf, NULL);

	// After written the sample, we no more need this buf.
	delete [] buf;

	RAW->setPan(-1.f);
	RAW->clone( (Stream**)&RAW2 );
	RAW->clone( (Stream**)&RAW3 );
	RAW3->setPan(1.f);
	RAW3->clone( (Stream**)&RAW4 );
	RAW->play();
	RAW2->play();
	RAW3->play();
	RAW4->play();

	for (int freq = 1000; freq < 80000; freq += 100) {
		RAW->setFrequency(freq);
		RAW3->setFrequency(freq + 100);
		RAW2->setFrequency(100000 - freq);
		RAW4->setFrequency(100100 - freq);
		Sleep(10);
	}

	printf("\nPress any key to quit.\n");
	getch();

	// -----------------------------
	// Note about GAudio destructor:
	// in theory, there is no need to call release() method of each class because GAudio destructor
	// automatically does. However it's quite recommanded to do it for a cleaner and safety program.
	// For this simple example, GAudio destructor will do the job ..

	delete gAudio;
}
