
/*
	GAudio 2.0.2, (C)2001 by Obraz Studio(R)
	This program is a part of the GAudio 2.0.2 SDK.

	Load a WAV file and play it.
*/

	#include <conio.h>
	#include <stdio.h>
	#include "../../include/gaudio.h"

	using namespace gaudio;

unsigned	DllVersion;
GAudio		*gAudio;
WAVstream	*WAV;

void main()
{
	ErrCode err;

	DllVersion = getLibVersion();
	
	char rev = DllVersion & 0xf;
	char sec = (DllVersion >> 4) & 0xf;
	char prim = (DllVersion >> 8) & 0xf;
	printf("GAudio library version %ld.%ld.%ld\n\n", prim, sec, rev);

	printf("This example demonstrates how to load a WAV file and play it.\nNo use of GAudio software mixer, pure DirectSound.\n");
	printf("Press any key to start ..\n");
	getch();

	gAudio = new GAudio();
	err = gAudio->init(DEVICE_DSOUND, DEVICEFREQ_44K, FALSE);
	if (err != GA_OK) {
		printf(gAudio->getLastErrorString());
		getch();
		delete gAudio;
		return;
	}

	StreamParameters WAVParams;
	ZeroMemory(&WAVParams, sizeof WAVParams);
	WAVParams.classID = CLSID_WAVSTREAM;
	WAVParams.fileName = "../../audio bin/rythm.wav";
	WAVParams.flags = FLAG_LOOP;
	WAVParams.input = INPUT_DISK;
	WAVParams.output = OUTPUT_DSOUND;

	err = gAudio->getSoundClass(SOUNDCLASS_WAV, &WAVParams, (void**)&WAV);
	if (err != GA_OK) {
		printf(gAudio->getLastErrorString());
		getch();
		delete gAudio;
		return;
	}

	WAV->play();

	printf("\nPlaying, press any key to quit.\n");
	getch();

	WAV->release();
	delete gAudio;
}
