
/*
	GAudio 2.0.2, (C)2001 by Obraz Studio(R)
	This program is a part of the GAudio 2.0.2 SDK.

	Load a XM file and play it using DirectSound only (benefits of hardware mixer acceleration where available).
*/

	#include <conio.h>
	#include <stdio.h>
	#include "../../include/gaudio.h"

	using namespace gaudio;

unsigned	DllVersion;
GAudio		*gAudio;
TrackerXM	*XM;

void main()
{
	ErrCode err;

	DllVersion = getLibVersion();

	char rev = DllVersion & 0xf;
	char sec = (DllVersion >> 4) & 0xf;
	char prim = (DllVersion >> 8) & 0xf;
	printf("GAudio library version %ld.%ld.%ld\n\n", prim, sec, rev);

	printf("This example demonstrates how to load a XM file and play it using entirely\nDirectSound mixer. It also takes profit of any eventual hardware acceleration.");
	printf("\nPress any key to start ..\n");
	getch();

	gAudio = new GAudio();
	err = gAudio->init(DEVICE_DSOUND, DEVICEFREQ_44K, FALSE);
	if (err != GA_OK) {
		printf(gAudio->getLastErrorString());
		getch();
		delete gAudio;
		return;
	}

	TrackerParameters XMParams;
	ZeroMemory(&XMParams, sizeof XMParams);
	XMParams.classID = CLSID_TRACKERXM;
	XMParams.fileName = "../../audio bin/newest.xm";
	XMParams.flags = FLAG_LOOP;
	XMParams.input = INPUT_DISK;
	XMParams.output = OUTPUT_DSOUND;

	err = gAudio->getSoundClass(SOUNDCLASS_XM, &XMParams, (void**)&XM);
	if (err != GA_OK) {
		printf(gAudio->getLastErrorString());
		getch();
		delete gAudio;
		return;
	}

	XM->play();

	printf("\nPlaying, press any key to quit.\n");
	getch();

	XM->release();
	delete gAudio;
}
